var currentFocus;

new Vue({
    el: '#appCMPFacturaCrear',
    data: {
        proveedor: document.getElementById('id_proveedor_fac').value,
        observaciones: '',
        articulosTotal: 0,
        descuento: 0,
        subtotal: 0,
        total: 0,
        neto: 0,
        iva: 0,
        productos: [],
        carrito: [],
        cargando: false,
        errorForm: [],
        afectar_stock: false,
        afectar_precio: false,
        divisa_nombre: '',
        almacen_nombre: '',
        toggleBarcode: false,
        money: {
            locale: '',
            decimal: '.',
            thousands: ',',
            prefix: '',
            suffix: '',
            precision: 2,
            masked: false /* doesn't work with directive */
        },
    },
    created() {
        axios.get('compras/obtenerDivisaPredeterminada').then(response => {
            this.money.locale = response.data.locale;
            this.money.prefix = response.data.symbol + ' ';
            this.money.decimal = response.data.decimal;
            this.money.thousands = response.data.thousands;
            this.money.precision = response.data.precision;
        }).catch(e => notificacion());
    },
    mounted() {
        document.getElementById('buscador').focus();
    },
    methods: {
        cambiarAlmacen() {
            axios.get('cmpfactura/cambiarAlmacen/' + this.proveedor).then(response => {
                if (response.data == true) {
                    this.productos = [];
                    this.articulosTotal = 0;
                    this.subtotal = 0;
                    this.descuento = 0;
                    this.neto = 0;
                    this.iva = 0;
                    this.total = 0;
                    this.carrito = [];
                } else {
                    location.reload();
                }
            }).catch(e => notificacion());
        },
        predeterminarDivisa(event) {
            axios.get('cmpfactura/predeterminarDivisa', {
                params: {
                    'id_proveedor': this.proveedor,
                    'id_divisa': event.target.value,
                    'descuento': this.descuento
                }
            }).then(response => {
                if (response.data.errors == null) {
                    if (Object.keys(response.data.divisa).length > 0) {
                        this.money.locale = response.data.divisa.locale;
                        this.money.prefix = response.data.divisa.symbol + ' ';
                        this.money.decimal = response.data.divisa.decimal;
                        this.money.thousands = response.data.divisa.thousands;
                        this.money.precision = response.data.divisa.precision;
                    }
                    if (Object.keys(response.data.data_carrito).length > 0) {
                        this.articulosTotal = response.data.data_carrito.articulos_cantidad;
                        this.subtotal = response.data.data_carrito.subtotal;
                        this.descuento = response.data.data_carrito.descuento;
                        this.neto = response.data.data_carrito.neto;
                        this.iva = response.data.data_carrito.iva;
                        this.total = response.data.data_carrito.total;
                        this.carrito = response.data.data_carrito.carrito;
                    }
                } else {
                    let total_errores = response.data.errors.length
                    for (let i = 0; i < total_errores; i++) {
                        notificacion('fa fa-ban', 'Advertencia', response.data.errors[i], 'warning');
                    }
                }
            }).catch(e => notificacion());
        },
        buscarProducto(event) {
            this.search(event.target.value, event, this);
        },
        search: _.debounce((search, event, vm) => {

            if (vm.toggleBarcode == false) {

                currentFocus = 0;
                let a, b;
                var x = document.getElementsByClassName("autocomplete-items");

                for (var i = 0; i < x.length; i++) {
                    x[i].parentNode.removeChild(x[i]);
                }

                if (!search) {
                    return false;
                }

                axios.get('cmpfactura/buscarProducto', {
                    params: {
                        'divisa': vm.$refs.divisa_predeterminada.value,
                        'almacen': vm.$refs.almacen_predeterminado.value,
                        'buscar': search.trim(),
                    }
                }).then(response => {
                    vm.productos = response.data;
                }).catch(e => {
                    notificacion();
                }).finally(() => {

                    currentFocus = -1;

                    a = document.createElement("div");
                    a.id = event.target.id + 'autocomplete-list';
                    a.classList.add('autocomplete-items');
                    event.target.parentNode.appendChild(a);

                    let self = vm;

                    vm.productos.forEach((item) => {

                        b = document.createElement("div");

                        if (item.imagen) {
                            b.innerHTML += "<img src='" + item.imagen + "' class='avatar-img rounded-circle' style='width: 50px; height: 50px; margin-right: 15px'>";
                        }

                        if (item.pro_descripcion.substr(0, search.length).toUpperCase() == search.toUpperCase()) {
                            b.innerHTML += "<strong>" + item.pro_descripcion.substr(0, search.length) + "</strong>";
                            b.innerHTML += "<span>" + item.pro_descripcion.substr(search.length) + "</span>";
                        } else {
                            b.innerHTML += "<strong>" + item.pro_descripcion + "</strong>";
                        }

                        b.innerHTML += "<small class='text-primary' style='margin-right: 5px'> stock: " + item.ps_cantidad + "</small> <br>";
                        b.innerHTML += "<small class='text-primary' style='margin-right: 10px'> fabricante: " + item.fabricante + "</small>";
                        b.innerHTML += "<input type='hidden' value='" + item.pro_id + "' data-almacen='" + item.id_almacen + "' data-name='" + item.pro_descripcion + "'>";

                        b.addEventListener("click", function (e) {

                            event.target.value = this.getElementsByTagName("input")[0].getAttribute('data-name');
                            let id_producto = this.getElementsByTagName("input")[0].value;
                            let id_almacen = this.getElementsByTagName("input")[0].getAttribute('data-almacen');

                            self.agregarProducto(id_producto, id_almacen);

                            for (var i = 0; i < x.length; i++) {
                                x[i].parentNode.removeChild(x[i]);
                            }
                        });

                        a.appendChild(b);
                    });
                });
            }
        }, 500),
        agregarProducto(id_producto, id_almacen) {
            if (this.$refs.divisa_predeterminada.value && id_producto && id_almacen && this.proveedor) {
                axios({
                    method: 'post',
                    url: 'cmpfactura/agregarProducto',
                    data: {
                        'id_proveedor': this.proveedor,
                        'id_producto': id_producto,
                        'id_almacen': id_almacen,
                        'id_divisa': this.$refs.divisa_predeterminada.value,
                        'descuento_global': this.descuento,
                    },
                    transformRequest: serializar(),
                }).then(response => {
                    if (response.data.errors == null) {
                        this.articulosTotal = response.data.articulos_cantidad;
                        this.subtotal = response.data.subtotal;
                        this.descuento = response.data.descuento;
                        this.neto = response.data.neto;
                        this.iva = response.data.iva;
                        this.total = response.data.total;
                        this.carrito = response.data.carrito;
                    } else {
                        let total_errores = response.data.errors.length
                        for (let i = 0; i < total_errores; i++) {
                            notificacion('fa fa-ban', 'Advertencia', response.data.errors[i], 'warning');
                        }
                    }
                }).catch(e => notificacion()).finally(() => {
                    document.getElementById('buscador').value = '';
                });
            }
        },
        seleccionarProducto(event) {

            var x = document.getElementById(event.target.id + 'autocomplete-list');

            if (x) x = x.getElementsByTagName("div");

            if (event.key == 'ArrowDown') {
                currentFocus++;
                active(x);
            } else if (event.key == 'ArrowUp') {
                currentFocus--;
                active(x);
            } else if (event.key == 'Enter') {

                event.preventDefault();

                if (this.toggleBarcode == true) {
                    this.agregarProductoBarcode(event.target.value);
                    document.getElementById('buscador').value = '';
                } else {
                    if (currentFocus > -1) {
                        if (x) x[currentFocus].click();
                    }
                }

            }
        },
        actualizarPrecio(unique, event) {
            let precio = convertir_a_float(event.target.value);
            if (event.target.value && precio > 0 && unique && this.proveedor) {
                this.atc_pre(event.target.value, unique, this)
            }
        },
        atc_pre: _.debounce((value, unique, vm) => {
            axios({
                method: 'post',
                url: 'cmpfactura/actualizarPrecio',
                data: {
                    'id_proveedor': vm.proveedor,
                    'unique': unique,
                    'precio': value,
                    'descuento_global': vm.descuento,
                },
                transformRequest: serializar(),
            }).then(response => {
                if (response.data.errors == null) {
                    vm.articulosTotal = response.data.articulos_cantidad;
                    vm.subtotal = response.data.subtotal;
                    vm.descuento = response.data.descuento;
                    vm.neto = response.data.neto;
                    vm.iva = response.data.iva;
                    vm.total = response.data.total;
                    Object.keys(response.data.carrito).forEach((key, i) => {
                        vm.carrito[key].neto = response.data.carrito[key].neto;
                        vm.carrito[key].total = response.data.carrito[key].total;
                    });
                } else {
                    let total_errores = response.data.errors.length
                    for (let i = 0; i < total_errores; i++) {
                        notificacion('fa fa-ban', 'Advertencia', response.data.errors[i], 'warning');
                    }
                }
            }).catch(e => notificacion());
        }, 300),
        actualizarCantidad(id_producto, event) {
            let cantidad = convertir_a_float(event.target.value);
            if (event.target.value && cantidad > 0) {
                this.debounce_actualizarCantidad(event.target.value, id_producto, this);
            }
        },
        debounce_actualizarCantidad: _.debounce((value, id_producto, vm) => {
            axios({
                method: 'post',
                url: 'cmpfactura/actualizarCantidad',
                data: {
                    id_proveedor: vm.proveedor,
                    id_producto: id_producto,
                    cantidad: value,
                    descuento_global: vm.descuento,
                    id_factura: vm.id_factura
                },
                transformRequest: serializar(),
            }).then(response => {
                if (response.data.errors == null) {
                    vm.articulosTotal = response.data.articulos_cantidad;
                    vm.subtotal = response.data.subtotal;
                    vm.descuento = response.data.descuento;
                    vm.neto = response.data.neto;
                    vm.iva = response.data.iva;
                    vm.total = response.data.total;
                    Object.keys(response.data.carrito).forEach((key, i) => {
                        vm.carrito[key].neto = response.data.carrito[key].neto;
                        vm.carrito[key].total = response.data.carrito[key].total;
                    });
                } else {
                    if (response.data.cantidad > 0) {
                        value = response.data.cantidad;
                    }
                    let total_errores = response.data.errors.length
                    for (let i = 0; i < total_errores; i++) {
                        notificacion('fa fa-ban', 'Advertencia', response.data.errors[i], 'warning');
                    }
                }
            }).catch(e => notificacion());
        }, 300),
        aplicarNuevoIva(unique, id_iva) {
            if (unique && id_iva && this.proveedor) {
                axios({
                    method: 'post',
                    url: 'cmpfactura/aplicarNuevoIva',
                    data: {
                        'id_proveedor': this.proveedor,
                        'unique': unique,
                        'id_iva': id_iva,
                        'descuento_global': this.descuento,
                    },
                    transformRequest: serializar(),
                }).then(response => {
                    if (response.data.errors == null) {
                        this.articulosTotal = response.data.articulos_cantidad;
                        this.subtotal = response.data.subtotal;
                        this.descuento = response.data.descuento;
                        this.neto = response.data.neto;
                        this.iva = response.data.iva;
                        this.total = response.data.total;
                        this.carrito = response.data.carrito;
                    } else {
                        let total_errores = response.data.errors.length
                        for (let i = 0; i < total_errores; i++) {
                            notificacion('fa fa-ban', 'Advertencia', response.data.errors[i], 'warning');
                        }
                    }
                }).catch(e => notificacion());
            } else {
                let total_errores = this.errorForm.length
                for (let i = 0; i < total_errores; i++) {
                    notificacion('fa fa-ban', 'Advertencia', this.errorForm[i], 'warning');
                }
            }
        },
        aplicarDescuentoProducto(unique, event) {
            let descuento_ = convertir_a_float(event.target.value);
            if (unique && this.proveedor) {
                axios({
                    method: 'post',
                    url: 'cmpfactura/aplicarDescuentoProducto',
                    data: {
                        'id_proveedor': this.proveedor,
                        'unique': unique,
                        'descuento': descuento_,
                        'descuento_global': this.descuento,
                    },
                    transformRequest: serializar(),
                }).then(response => {
                    if (response.data.errors == null) {
                        this.articulosTotal = response.data.articulos_cantidad;
                        this.subtotal = response.data.subtotal;
                        this.descuento = response.data.descuento;
                        this.neto = response.data.neto;
                        this.iva = response.data.iva;
                        this.total = response.data.total;
                        Object.keys(response.data.carrito).forEach((key, i) => {
                            this.carrito[key].neto = response.data.carrito[key].neto;
                            this.carrito[key].total = response.data.carrito[key].total;
                        });
                    } else {
                        let total_errores = response.data.errors.length
                        for (let i = 0; i < total_errores; i++) {
                            notificacion('fa fa-ban', 'Advertencia', response.data.errors[i], 'warning');
                        }
                    }
                }).catch(e => notificacion());
            } else {
                let total_errores = this.errorForm.length
                for (let i = 0; i < total_errores; i++) {
                    notificacion('fa fa-ban', 'Advertencia', this.errorForm[i], 'warning');
                }
            }
        },
        aplicarDescuentoAdicional() {
            if (!isNaN(this.descuento) && this.descuento >= 0) {
                axios({
                    method: 'post',
                    url: 'cmpfactura/aplicarDescuentoAdicional',
                    data: {
                        'descuento': this.descuento,
                        'id_proveedor': this.proveedor,
                    },
                    transformRequest: serializar(),
                }).then(response => {
                    if (response.data.errors == null) {
                        this.articulosTotal = response.data.articulos_cantidad;
                        this.subtotal = response.data.subtotal;
                        this.neto = response.data.neto;
                        this.iva = response.data.iva;
                        this.total = response.data.total;
                    } else {
                        let total_errores = response.data.errors.length
                        for (let i = 0; i < total_errores; i++) {
                            notificacion('fa fa-ban', 'Advertencia', response.data.errors[i], 'warning');
                        }
                    }
                }).catch(e => notificacion());
            }
        },
        eliminarProducto(unique) {
            if (this.proveedor && unique) {
                axios({
                    method: 'post',
                    url: 'cmpfactura/eliminarProducto',
                    data: {
                        'unique': unique,
                        'id_proveedor': this.proveedor,
                        'descuento_global': this.descuento,
                    },
                    transformRequest: serializar(),
                }).then(response => {
                    if (response.data.errors == null) {
                        this.articulosTotal = response.data.articulos_cantidad;
                        this.subtotal = response.data.subtotal;
                        this.descuento = response.data.descuento;
                        this.neto = response.data.neto;
                        this.iva = response.data.iva;
                        this.total = response.data.total;
                        this.carrito = response.data.carrito;
                    } else {
                        let total_errores = response.data.errors.length
                        for (let i = 0; i < total_errores; i++) {
                            notificacion('fa fa-ban', 'Advertencia', response.data.errors[i], 'warning');
                        }
                    }
                }).catch(e => notificacion());
            }
        },
        actualizarDetalles() {

            this.errorForm = [];

            let dataFormClienteDetalle = {
                'id': this.proveedor,
                'prov_tipoidfiscal': document.getElementById('prov_tipoidfiscal').value,
                'prov_cifnif': document.getElementById('prov_cifnif').value,
                'prov_razonsocial': document.getElementById('prov_razonsocial').value,
                'prov_email': '',
                'prov_telefono1': '',
                'prov_telefono2': '',
                'prov_direccion': document.getElementById('prov_direccion').value,
                'prov_paisid': document.getElementById('prov_paisid').value,
                'prov_estado': document.getElementById('prov_estado').value,
                'prov_ciudad': document.getElementById('prov_ciudad').value,
                'prov_codigo_postal': document.getElementById('prov_codigo_postal').value,
            };

            if (!dataFormClienteDetalle.prov_tipoidfiscal)
                this.errorForm.push('El campo Tipo de Documento es obligatorio');
            if (!dataFormClienteDetalle.prov_cifnif)
                this.errorForm.push('El campo Número de Documento es obligatorio.');
            if (!dataFormClienteDetalle.prov_direccion)
                this.errorForm.push('El campo Dirección es obligatorio');
            if (!dataFormClienteDetalle.prov_razonsocial)
                this.errorForm.push('El campo Razón Social es obligatorio.');

            if (this.errorForm.length == 0) {
                this.cargando = true;
                axios({
                    method: 'post',
                    url: 'cmpfactura/guardarDetallesCliente',
                    data: dataFormClienteDetalle,
                    transformRequest: serializar(),
                }).then(response => {
                    if (response.data.errors == null) {
                        if (response.data == true) {
                            document.getElementById('cabecera_cliente').innerHTML = dataFormClienteDetalle.prov_razonsocial + ' ' + dataFormClienteDetalle.prov_cifnif;
                            notificacion('fa fa-edit', '', 'Actualización exitosa', 'info');
                        }
                    } else {
                        let total_errores = response.data.errors.length
                        for (let i = 0; i < total_errores; i++) {
                            notificacion('fa fa-ban', 'Advertencia', response.data.errors[i], 'warning');
                        }
                    }
                }).catch(e => notificacion()).finally(() => this.cargando = false);
            } else {
                let total_errores = this.errorForm.length
                for (let i = 0; i < total_errores; i++) {
                    notificacion('fa fa-ban', 'Advertencia', this.errorForm[i], 'warning');
                }
            }
        },
        actualizarDescripcion(unique, event) {

            this.errorForm = [];

            if (!event.target.value)
                this.errorForm.push('La descripción no debe quedar vacía.');

            if (this.proveedor && this.errorForm.length == 0) {
                axios({
                    method: 'post',
                    url: 'cmpfactura/actualizarDescripcion',
                    data: {
                        'id_proveedor': this.proveedor,
                        'unique': unique,
                        'descripcion': event.target.value,
                    },
                    transformRequest: serializar(),
                }).then(response => {
                    if (response.data.errors) {
                        let total_errores = response.data.errors.length;
                        for (let i = 0; i < total_errores; i++) {
                            notificacion('fa fa-ban', 'Advertencia', response.data.errors[i], 'warning');
                        }
                    }
                }).catch(e => notificacion());
            } else {
                let total_errores = this.errorForm.length
                for (let i = 0; i < total_errores; i++) {
                    notificacion('fa fa-ban', 'Advertencia', this.errorForm[i], 'warning');
                }
            }
        },
        guardarFactura() {

            axios.get('notasdeentrega/nombreDivisa/' + this.$refs.divisa_predeterminada.value).then(response => {
                this.divisa_nombre = response.data
            });

            axios.get('notasdeentrega/nombreAlmacen/' + this.$refs.almacen_predeterminado.value).then(response => {

                if (response.data) {

                    this.almacen_nombre = response.data;

                    Swal.fire({
                        title: '<strong>¿Continuar?</strong>',
                        html: 'Documento: <strong>Factura en Compras </strong> <br>' +
                            'Divisa: <strong>' + this.divisa_nombre + '</strong>' +
                            'Almacen: <strong>' + this.almacen_nombre + '</strong>',
                        showCloseButton: true,
                        showCancelButton: true,
                        focusConfirm: true,
                        confirmButtonText: 'SI',
                        confirmButtonAriaLabel: 'SI',
                        cancelButtonText: 'NO',
                        cancelButtonAriaLabel: 'NO',
                        confirmButtonColor: '#3085d6',
                        cancelButtonColor: '#aaa'
                    }).then((result) => {

                        if (result.value) {

                            Swal.mixin({
                                input: 'checkbox',
                                confirmButtonText: 'Siguiente &rarr;',
                                showCancelButton: true,
                                cancelButtonText: 'Cancelar',
                                confirmButtonColor: '#3085d6',
                                cancelButtonColor: '#aaa',
                                progressSteps: ['1', '2']
                            }).queue([{
                                title: 'Afectar stock',
                                text: 'SI'
                            },
                            {
                                title: 'Afectar precio',
                                text: 'SI'
                            },
                            ]).then((result) => {

                                if (result.value) {

                                    this.afectar_stock = (result.value[0]) ? true : false;
                                    this.afectar_precio = (result.value[1]) ? true : false;

                                    result.value.forEach((element, index, array) => {
                                        if (element == 1) {
                                            result.value[index] = 'SI';
                                        } else {
                                            result.value[index] = 'NO';
                                        }
                                    });

                                    const answers = JSON.stringify(result.value)
                                    Swal.fire({
                                        title: '¡Todo listo!',
                                        html: `
                                      Tus respuestas:
                                      <pre><code>${answers}</code></pre>
                                    `,
                                        showCloseButton: true,
                                        showCancelButton: true,
                                        focusConfirm: true,
                                        confirmButtonText: 'Continuar',
                                        confirmButtonAriaLabel: 'Continuar',
                                        cancelButtonText: 'Cancelar',
                                        cancelButtonAriaLabel: 'Cancelar',
                                        confirmButtonColor: '#3085d6',
                                        cancelButtonColor: '#aaa'
                                    }).then((result) => {

                                        if (result.value) {

                                            this.errorForm = [];

                                            if (this.carrito.length == 0)
                                                this.errorForm.push('No ha seleccinado algún producto para la compra');
                                            if (!this.$refs.serie_predeterminada.value)
                                                this.errorForm.push('Debe seleccionar una serie');
                                            if (!document.getElementById('fecha').value)
                                                this.errorForm.push('Debe seleccionar una fecha');

                                            if (this.proveedor && this.errorForm.length == 0) {
                                                this.cargando = true;
                                                axios({
                                                    method: 'post',
                                                    url: 'cmpfactura/ventaEnEspera',
                                                    data: {
                                                        'id_serie': this.$refs.serie_predeterminada.value,
                                                        'id_proveedor': this.proveedor,
                                                        'fecha': document.getElementById('fecha').value,
                                                        'observaciones': this.observaciones,
                                                        afectar_stock: this.afectar_stock,
                                                        afectar_precio: this.afectar_precio
                                                    },
                                                    transformRequest: serializar(),
                                                }).then(response => {
                                                    if (response.data.errors == null) {
                                                        location.href = response.data;
                                                    } else {
                                                        let total_errores = response.data.errors.length
                                                        for (let i = 0; i < total_errores; i++) {
                                                            notificacion('fa fa-ban', 'Advertencia', response.data.errors[i], 'warning');
                                                        }
                                                    }
                                                }).catch(e => notificacion()).finally(() => this.cargando = false);
                                            } else {
                                                let total_errores = this.errorForm.length
                                                for (let i = 0; i < total_errores; i++) {
                                                    notificacion('fa fa-ban', 'Advertencia', this.errorForm[i], 'warning');
                                                }
                                            }
                                        }
                                    });
                                }
                            });
                        }
                    });
                }
            });
        },
        moneda(num, div_locale_, div_simbolo_, decimal_ = 2) {
            if (Object.keys(this.carrito).length > 0) {
                let monto_ = convertir_a_float(String(num).toString());
                return monedaMoneda(monto_, div_locale_, div_simbolo_, decimal_);
            }
        },
        decimal(num, div_locale_, decimal_ = 2) {
            if (Object.keys(this.carrito).length > 0) {
                let monto_ = convertir_a_float(String(num).toString());
                return monedaDecimal(monto_, div_locale_, decimal_);
            }
        }
    }
});

function active(x) {

    if (!x) return false;

    for (var i = 0; i < x.length; i++) {
        x[i].classList.remove("autocomplete-active");
    }

    if (currentFocus >= x.length) currentFocus = 0;
    if (currentFocus < 0) currentFocus = (x.length - 1);

    x[currentFocus].classList.add("autocomplete-active");
}

function closeAllLists(elmnt) {
    let inp = document.getElementById("buscador");
    let x = document.getElementsByClassName("autocomplete-items");
    for (var i = 0; i < x.length; i++) {
        if (elmnt != x[i] && elmnt != inp) {
            x[i].parentNode.removeChild(x[i]);
        }
    }
}

document.addEventListener("click", function (e) {
    closeAllLists(e.target);
});